#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>


#include "6legs.h"
#include "6legs_offline.h"

/**************************************************************/
/**  i^Ɋe֐߂ɏo߂̃f[^쐬                **/
/**  (leg_dmake9͗׍r̈ʑ0x)                     **/
/**  ~OA[[_bVspg`                    **/
/**  savo_filename  :T[{f[^o̓t@CirS{j  **/
/**************************************************************/
void leg_dmake9(char filename[16], struct LEG_PARAM leg_param[4], struct WAVE_PARAM wave_param)
{
int     i,j,flg,data_num;
int     servo_data[4][WAVE_MAX2][3], coo_pointer[10];
double   foot_coo0[4][WAVE_MAX2][3];
double   foot_coo1[WAVE_MAX2][3];
double   length,height,time[4];
double   dyy,off_z, leg_sign[4], vel[2];

FILE	*fpo;

	leg_sign[0] = 1.0;
	leg_sign[1] = 1.0;
	leg_sign[2] =-1.0;
	leg_sign[3] =-1.0;

	length	= wave_param.length;
	height	= wave_param.height;
	dyy		= wave_param.off_y;
	off_z	= wave_param.off_z;
	time[0] = wave_param.time[0];
	vel[0]	= wave_param.vel[0];
	vel[1]	= wave_param.vel[1];

	str_orbit6(length, height, vel, time[0], foot_coo1, coo_pointer);

	data_num = coo_pointer[0] + 1;
	/***************************************************************************************/
	for(i = 0; i < data_num; i++)
	{
		for(j = 0; j < 4; j++)
		{
			/*e֐߂j[g̎̈ʒuɋOՂ𕽍sړ*/
			foot_coo0[j][i][0] = foot_coo1[i][0] + leg_param[j].dx;
			foot_coo0[j][i][1] = foot_coo1[i][1] + leg_param[j].dy + dyy * leg_sign[j];
			foot_coo0[j][i][2] = foot_coo1[i][2] + leg_param[j].dz + off_z;

			//T[{f[^ɕϊ
			if(j == 0 || j == 1)
			{
				flg = legP_dcomv12(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}
			else
			{
				flg = legP_dcomv32(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}

			if(flg == 1)
			{
				printf("͂Ȃꏊw܂Bleg_dmake6\n");
				exit(0);
			}
		}
	}

	//t@Cɏ
	if ((fpo = fopen(filename, "wt")) != NULL)
	{
		for(i = 0; i < data_num; i++)
		{
			for(j = 0; j < 4; j++)
			{
				fprintf(fpo, "%d,%d,%d,", servo_data[j][i][0], servo_data[j][i][1], servo_data[j][i][2]);
			}
			fprintf(fpo,"\n");
		}
		fclose(fpo);
	}
	else
	{
		printf("ݗpt@CJ܂Bleg_dmake6: %s\n",filename);
		exit(0);
	}
	return;
}

