#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>


#include "6legs.h"
#include "6legs_offline.h"

void str_orbit03(double length, double length_y, double height,
				 int devide, double coo[4][WAVE_MAX2][3], int coo_pointer[10]);
void str_orbit02(double length, double height, int devide,
		double coo[4][WAVE_MAX2][3], int coo_pointer[10]);
void str_orbit01(double length, double height, int devide,
		double coo[4][WAVE_MAX2][3], int coo_pointer[10]);
void str_orbit0(double length, double height, int devide,
		double coo[4][WAVE_MAX2][3], int coo_pointer[10]);
/**************************************************************/
/**  i^Ɋe֐߂ɏo߂̃f[^쐬                **/
/**  (leg_dmake1͗׍r̈ʑ180x)                   **/
/**  ~OAspg`                                **/
/**  savo_filename  :T[{f[^o̓t@CirS{j  **/
/**************************************************************/
void leg_dmake0(char filename[16], struct LEG_PARAM leg_param[4], struct WAVE_PARAM wave_param)
{
int     i,j,flg;
int     coo_pointer[10],servo_data[4][WAVE_MAX2][3];
double   foot_coo0[4][WAVE_MAX2][3];
double   foot_coo1[WAVE_MAX2][3];
double   length,height,step;
double   dyy,off_z, leg_sign[4];
FILE	*fpo;

	leg_sign[0] = 1.0;
	leg_sign[1] = 1.0;
	leg_sign[2] =-1.0;
	leg_sign[3] =-1.0;

	length	= wave_param.length;
	height	= wave_param.height;
	step	= wave_param.pitch;
	dyy		= wave_param.off_y;
	off_z	= wave_param.off_z;

	//O
	for(i = 0; i < 4; i++)
	{
		if(i == 1 || i == 2)
		{
			str_orbit1(length, height, step, foot_coo1, coo_pointer);
			/*gꂽ_쐬*/
			harf_p_shift(coo_pointer[0], foot_coo1, foot_coo0[i]);
		}
		else
		{
			str_orbit1(length, height, step, foot_coo0[i], coo_pointer);
		}
	}

	for(i = 0; i <= coo_pointer[0]; i++)
	{
		for(j = 0; j < 4; j++)
		{
			/*e֐߂j[g̎̈ʒuɋOՂ𕽍sړ*/
			foot_coo0[j][i][0] = foot_coo0[j][i][0] + leg_param[j].dx;
			foot_coo0[j][i][1] = foot_coo0[j][i][1] + leg_param[j].dy + dyy * leg_sign[j];
			foot_coo0[j][i][2] = foot_coo0[j][i][2] + leg_param[j].dz + off_z;

			//T[{f[^ɕϊ
			if(j == 0 || j == 1)
			{
				flg = legP_dcomv12(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}
			else
			{
				flg = legP_dcomv32(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}

			if(flg == 1)
			{
				printf("͂Ȃꏊw܂Bleg_dmake1\n");
				exit(0);
			}
		}
	}

	//t@Cɏ
	if ((fpo = fopen(filename, "wt")) != NULL)
	{
		for(i = 0; i <= coo_pointer[0]; i++)
		{
			for(j = 0; j < 4; j++)
			{
				fprintf(fpo, "%d,%d,%d,", servo_data[j][i][0], servo_data[j][i][1], servo_data[j][i][2]);
			}
			fprintf(fpo,"\n");
		}
		fclose(fpo);
	}
	else
	{
		printf("ݗpt@CJ܂Bleg_dmake1: %s\n",filename);
		exit(0);
	}
	return;
}

/**************************************************************/
/**  i^Ɋe֐߂ɏo߂̃f[^쐬                **/
/**  ɂR{ȏ̋rŏdSx                    **/
/**  savo_filename  :T[{f[^o̓t@CirS{j  **/
/**************************************************************/
void leg_dmake1(char filename[16], struct LEG_PARAM leg_param[4])
{
int     i,j,devide,flg;
int     coo_pointer[10],servo_data[4][WAVE_MAX2][3];
char	work[64];
float		a;
double   foot_coo0[4][WAVE_MAX2][3];
double   length,length_y,height;
double   dyy, leg_sign[4],off_z;
FILE	*fpo;

	leg_sign[0] = 1.0;
	leg_sign[1] = 1.0;
	leg_sign[2] =-1.0;
	leg_sign[3] =-1.0;

	printf("PTCN̈ړ(X)͂ĉ(Pmm) :");
	scanf ("%f",&a);
	length = (double)a;

	printf("PTCN̈ړ(Y)͂ĉ(Pmm) :");
	scanf ("%f",&a);
	length_y = -(double)a;

	printf("߂Ƃグ鍂͂ĉ(Pmm) :");
	scanf ("%f",&a);
	height = (double)a;

	printf("1/3ڒnԂ͂̕ĂiRȏj:");
	scanf ("%d",&devide);

	printf("dyy(̒l͂ƓɃItZbg) :");
	scanf ("%s",work);
	dyy = atof(work);

	printf("off_z(̒l͂Ə㑤ɃItZbg) :");
	scanf ("%s",work);
	off_z = atof(work);


	//Sꂼ̋Oł
	str_orbit03(length, length_y, height, devide, foot_coo0, coo_pointer);

	for(i = 0; i <= coo_pointer[0]; i++)
	{
		for(j = 0; j < 4; j++)
		{
			/*e֐߂j[g̎̈ʒuɋOՂ𕽍sړ*/
			foot_coo0[j][i][0] = foot_coo0[j][i][0] + leg_param[j].dx;
			foot_coo0[j][i][1] = foot_coo0[j][i][1] + leg_param[j].dy + dyy * leg_sign[j];
			foot_coo0[j][i][2] = foot_coo0[j][i][2] + leg_param[j].dz + off_z;


			//ẼVtg
			if(j == 0 || j == 1)
			{
				flg = legP_dcomv12(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}
			else
			{
				flg = legP_dcomv32(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}

			if(flg == 1)
			{
				printf("͂Ȃꏊw܂Bleg_dmake1\n");
				exit(0);
			}
		}
	}

	//t@Cɏ
	if ((fpo = fopen(filename, "wt")) != NULL)
	{
		for(i = 0; i <= coo_pointer[0]; i++)
		{
			for(j = 0; j < 4; j++)
			{
				fprintf(fpo, "%d,%d,%d,", servo_data[j][i][0], servo_data[j][i][1], servo_data[j][i][2]);
			}
			fprintf(fpo,"\n");
		}
		fclose(fpo);
	}
	else
	{
		printf("ݗpt@CJ܂Bleg_dmake1: %s\n",filename);
		exit(0);
	}
	return;
}

/**************************************************************/
/**  ^Ɋe֐߂ɏo߂̃f[^쐬iɐj      **/
/**  (׍r̈ʑ180x)                               **/
/**  ~OAspg`                                **/
/**  filename  :T[{f[^o̓t@CirS{j       **/
/**************************************************************/
void leg_dmake2(char filename[16], struct LEG_PARAM leg_param[4], struct WAVE_PARAM wave_param)
{
int     i,j,flg,step_num;
int     coo_pointer[10],servo_data[4][WAVE_MAX2][3];
double   foot_coo0[4][WAVE_MAX2][3], diff[1][3];
double   foot_coo1[WAVE_MAX2][3];
double   length,height,step;
double   dyy,off_z, leg_sign[4];
double   foot_geo[6][3];
double   x,y,z,q0,r0,foot_r[6],foot_q[6],foot_l[6],PI;
FILE	*fpo;

	leg_sign[0] = 1.0;
	leg_sign[1] = 1.0;
	leg_sign[2] =-1.0;
	leg_sign[3] =-1.0;

	PI = 3.14159;

	length	= wave_param.length;
	height	= wave_param.height;
	step	= wave_param.pitch;
	dyy		= wave_param.off_y;
	off_z	= wave_param.off_z;
	r0		= wave_param.r;

	//O
	/**er̋OՂ̔aZbg*************************************/
	/*̒SWZbg*/
	x = 0.0;
	y = r0;
	z = 0.0;
	/*̃Xebv݂͋̍ł͂Ȃ*/
	for(i = 0; i < 4; i++)
	{
	   /*er̈ʒu֌W`*/
	   foot_geo[i][0] = leg_param[i].x;
	   foot_geo[i][1] = leg_param[i].y + dyy * leg_sign[i];
	   foot_geo[i][2] = leg_param[i].z;

	   /*̒Ser̒ʒu܂ł̋vZ*/
	   foot_r[i] = sqrt(pow((foot_geo[i][0] - x), 2)
	      + pow((foot_geo[i][1] - y), 2) + pow((foot_geo[i][2] - z), 2));
	
	   /*̒SƁA{bg̒S񂾐
	@              er̒ʒu܂ł̊pxvZ*/
	   foot_q[i] = atan2((foot_geo[i][1] - y), (foot_geo[i][0] - x))
			- PI / 2.0;

	   /*er̋OՂ̑ڒn̋OՂ̒vZ*/
	   q0 = length / r0;
	   foot_l[i] = fabs(foot_r[i] * q0);

	   /*XebvvZ*/
	   step_num = (int)(length / step);

	   /*̋OՁi~̒~j*********************************/
	   coo_pointer[9] = (int)r0;
	   tur_orbit1(foot_r[i], foot_l[i], height, step_num, step,	foot_coo1, coo_pointer);

	   /*j=LȔz̍ől*/
	   j = coo_pointer[0] + 1; /*palla_conv3Dstrorbit1͔ẑl`w̌Ⴄ*/

	   /*eOՃf[^]*/
	   rotate_1DZ(foot_coo1, 0.0, 0.0, foot_q[i], j);

	   /*e֐߂j[g̎̈ʒuɋOՂ𕽍sړ*/
	   diff[0][0] = leg_param[i].dx;
	   diff[0][1] = leg_param[i].dy + dyy * leg_sign[i];
	   diff[0][2] = leg_param[i].dz + off_z;

	   palla_conv3D(foot_coo1, diff, j, 1.0);

	   /*g`ʒuŏI悤ɃVtg*/
	   if(i == 1 || i == 2)
	   {
			wave_shift2(coo_pointer[1] + 1, coo_pointer[0], foot_coo1);
			/*gꂽ_쐬*/
			harf_p_shift(coo_pointer[0], foot_coo1, foot_coo0[i]);
	   }
	   else
	   {
			wave_shift(coo_pointer[1] + 1, coo_pointer[0], foot_coo1, foot_coo0[i]);
	   }
	}

	for(i = 0; i <= coo_pointer[0]; i++)
	{
		for(j = 0; j < 4; j++)
		{
			//T[{f[^ɕϊ
			if(j == 0 || j == 1)
			{
				flg = legP_dcomv12(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}
			else
			{
				flg = legP_dcomv32(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}

			if(flg == 1)
			{
				printf("͂Ȃꏊw܂Bleg_dmake1\n");
				exit(0);
			}
		}
	}

	//t@Cɏ
	if ((fpo = fopen(filename, "wt")) != NULL)
	{
		for(i = 0; i <= coo_pointer[0]; i++)
		{
			for(j = 0; j < 4; j++)
			{
				fprintf(fpo, "%d,%d,%d,", servo_data[j][i][0], servo_data[j][i][1], servo_data[j][i][2]);
			}
			fprintf(fpo,"\n");
		}
		fclose(fpo);
	}
	else
	{
		printf("ݗpt@CJ܂Bleg_dmake2: %s\n",filename);
		exit(0);
	}
	return;
}

/**************************************************************/
/**  ^Ɋe֐߂ɏo߂̃f[^쐬iMnj  **/
/**  (׍r̈ʑ180x)                               **/
/**  ~OAspg`                                **/
/**  filename  :T[{f[^o̓t@CirS{j       **/
/**************************************************************/
void leg_dmake3(char filename[16], struct LEG_PARAM leg_param[4], struct WAVE_PARAM wave_param)
{
int     i,j,k,flg,step_num;
int     coo_pointer[10],servo_data[4][WAVE_MAX2][3];
double   foot_coo0[4][WAVE_MAX2][3], diff[1][3];
double   foot_coo1[4][WAVE_MAX2][3];
double   length,height,step;
double   dyy,off_z, leg_sign[4];
double   foot_geo[6][3];
double   x,y,z,q,q0,r0,foot_r[6],foot_q[6],foot_l[6],PI;
FILE	*fpo;

	leg_sign[0] = 1.0;
	leg_sign[1] = 1.0;
	leg_sign[2] =-1.0;
	leg_sign[3] =-1.0;

	PI = 3.14159;

	length	= wave_param.length;
	height	= wave_param.height;
	step	= wave_param.pitch;
	dyy		= wave_param.off_y;
	off_z	= wave_param.off_z;
	r0		= (-105.5 - 40.0 - 10) * wave_param.dir_sign;

	//O
	/**er̋OՂ̔aZbg*************************************/
	/*̒SWZbg*/
	x = 0.0;
	y = 0.0;
	z = 0.0;
	/*̃Xebv݂͋̍ł͂Ȃ*/
	for(i = 0; i < 4; i++)
	{
		/*er̈ʒu֌W`*/
		foot_geo[i][0] = leg_param[i].x;
		foot_geo[i][1] = leg_param[i].y + dyy * leg_sign[i];
		foot_geo[i][2] = leg_param[i].z;

		/*̒Ser̒ʒu܂ł̋vZ*/
		foot_r[i] = sqrt(pow((foot_geo[i][0] - x), 2)
	      + pow((foot_geo[i][1] - y), 2) + pow((foot_geo[i][2] - z), 2));
	
		/*̒SƁA{bg̒S񂾐
	@              er̒ʒu܂ł̊pxvZ*/
		foot_q[i] = atan2((foot_geo[i][1] - y), (foot_geo[i][0] - x))
			- PI / 2.0;

		/*er̋OՂ̑ڒn̋OՂ̒vZ*/
		q0 = length / r0;
		foot_l[i] = fabs(foot_r[i] * q0);

		/*XebvvZ*/
		step_num = (int)(length / step);

		/*̋OՁi~̒~j*********************************/
		coo_pointer[9] = (int)r0;
		tur_orbit1(foot_r[i], foot_l[i], height, step_num, step, foot_coo0[i], coo_pointer);

		/*j=LȔz̍ől*/
		j = coo_pointer[0] + 1; /*palla_conv3Dstrorbit1͔ẑl`w̌Ⴄ*/

		/*eOՃf[^]*/
		q = foot_q[i];
		rotate_1DZ(foot_coo0[i], 0.0, 0.0, q, j);

		/*e֐߂j[g̎̈ʒuɋOՂ𕽍sړ*/
		diff[0][0] = leg_param[i].dx;
		diff[0][1] = leg_param[i].dy + dyy * leg_sign[i];
		diff[0][2] = leg_param[i].dz + off_z;

		palla_conv3D(foot_coo0[i], diff, j, 1.0);

		/*g`ʒuŏI悤ɃVtg*/
		wave_shift(coo_pointer[1] + 1, coo_pointer[0], foot_coo0[i], foot_coo1[i]);
		for(j = 0; j <= coo_pointer[0]; j++)
		{
			for(k = 0; k < 3; k++) foot_coo0[i][j][k] = foot_coo1[i][j][k];
		}

		/*gꂽ_쐬*/
		if(i == 1 || i == 2)
			harf_p_shift(coo_pointer[0], foot_coo0[i], foot_coo1[i]);
	}


	for(i = 0; i <= coo_pointer[0]; i++)
	{
		for(j = 0; j < 4; j++)
		{
			//T[{f[^ɕϊ
			if(j == 0)
			{
				flg = legP_dcomv12(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}
			if(j == 1)
			{
				flg = legP_dcomv12(foot_coo1[j][i], servo_data[j][i], leg_param[j], 0);
			}
			if(j == 2)
			{
				flg = legP_dcomv32(foot_coo1[j][i], servo_data[j][i], leg_param[j], 0);
			}
			if(j == 3)
			{
				flg = legP_dcomv32(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}
			if(flg == 1)
			{
				printf("͂Ȃꏊw܂Bleg_dmake3\n");
				exit(0);
			}
		}
	}

	//t@Cɏ
	if ((fpo = fopen(filename, "wt")) != NULL)
	{
		for(i = 0; i <= coo_pointer[0]; i++)
		{
			for(j = 0; j < 4; j++)
			{
				fprintf(fpo, "%d,%d,%d,", servo_data[j][i][0], servo_data[j][i][1], servo_data[j][i][2]);
			}
			fprintf(fpo,"\n");
		}
		fclose(fpo);
	}
	else
	{
		printf("ݗpt@CJ܂Bleg_dmake2: %s\n",filename);
		exit(0);
	}
	return;
}

