#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>


#include "6legs.h"
#include "6legs_offline.h"

/**************************************************************/
/**  ^Ɋe֐߂ɏo߂̃f[^쐬iMnj  **/
/**  (׍r̈ʑ0x)                                 **/
/**  `OAᑬspg`                                **/
/**  filename  :T[{f[^o̓t@CirS{j       **/
/**************************************************************/
void leg_dmake8(char filename[16], struct LEG_PARAM leg_param[4], struct WAVE_PARAM wave_param)
{
int     i,j,flg,step_num;
int     coo_pointer[10],servo_data[4][WAVE_MAX2][3];
double   foot_coo0[4][WAVE_MAX2][3], diff[1][3];
double   foot_coo1[WAVE_MAX2][3];
double   length,height,step;
double   dyy,off_z, leg_sign[4];
double   foot_geo[6][3];
double   x,y,z,q0,r0,foot_r[6],foot_q[6],foot_l[6],PI;
double	time[4];
FILE	*fpo;

	leg_sign[0] = 1.0;
	leg_sign[1] = 1.0;
	leg_sign[2] =-1.0;
	leg_sign[3] =-1.0;

	PI = 3.14159;
	/*p[^*************************************************/
	length	= wave_param.length;
	height	= wave_param.height;
	dyy		= wave_param.off_y;
	off_z	= wave_param.off_z;
	time[0] = wave_param.time[0];
	time[1] = wave_param.time[1];
	time[3] = wave_param.time[3];


//	time[1] = time[0] * 0.7;//グ
	time[2] = time[0] * 0.2;//Oɑ
//	time[3] = time[0] * 0.8;//낷

	//O
	/**er̋OՂ̔aZbg*************************************/
	/*̒SWZbg*/
	x = 0.0;
	y = 0.0;
	z = 0.0;
	r0 = (-105.5 - 40.0 - 10) * wave_param.dir_sign;
	for(i = 0; i < 4; i++)
	{
	   /*er̈ʒu֌W`*/
	   foot_geo[i][0] = leg_param[i].x;
	   foot_geo[i][1] = leg_param[i].y + dyy * leg_sign[i];
	   foot_geo[i][2] = leg_param[i].z;

	   /*̒Ser̒ʒu܂ł̋vZ*/
	   foot_r[i] = sqrt(pow((foot_geo[i][0] - x), 2)
	      + pow((foot_geo[i][1] - y), 2) + pow((foot_geo[i][2] - z), 2));
	
	   /*̒SƁA{bg̒S񂾐
	@              er̒ʒu܂ł̊pxvZ*/
	   foot_q[i] = atan2((foot_geo[i][1] - y), (foot_geo[i][0] - x))
			- PI / 2.0;

	   /*er̋OՂ̑ڒn̋OՂ̒vZ*/
	   q0 = length / r0;
	   foot_l[i] = fabs(foot_r[i] * q0);

	   /*XebvvZ*/
	   step_num = (int)(length / step);

	   /*̋OՁi~̒~j*********************************/
	   coo_pointer[9] = (int)r0;
	   tur_orbit2(foot_r[i], foot_l[i], height, time,	foot_coo1, coo_pointer);

	   /*j=LȔz̍ől*/
	   j = coo_pointer[0] + 1; /*palla_conv3Dstrorbit1͔ẑl`w̌Ⴄ*/

	   /*eOՃf[^]*/
	   rotate_1DZ(foot_coo1, 0.0, 0.0, foot_q[i], j);

	   /*e֐߂j[g̎̈ʒuɋOՂ𕽍sړ*/
	   diff[0][0] = leg_param[i].dx;
	   diff[0][1] = leg_param[i].dy + dyy * leg_sign[i];
	   diff[0][2] = leg_param[i].dz + off_z;

	   palla_conv3D(foot_coo1, diff, j, 1.0);

	   /*g`ʒuŏI悤ɃVtg*/
	   if(i == 0 || i == 1)
	   {
			wave_shift(coo_pointer[1], coo_pointer[0], foot_coo1, foot_coo0[i]);
	   }
	   else
	   {
			wave_shift(coo_pointer[1], coo_pointer[0], foot_coo1, foot_coo0[i]);
	   }
	}

	for(i = 0; i <= coo_pointer[0]; i++)
	{
		for(j = 0; j < 4; j++)
		{
			//T[{f[^ɕϊ
			if(j == 0 || j == 1)
			{
				flg = legP_dcomv12(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}
			else
			{
				flg = legP_dcomv32(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}

			if(flg == 1)
			{
				printf("͂Ȃꏊw܂Bleg_dmake1\n");
				exit(0);
			}
		}
	}

	//t@Cɏ
	if ((fpo = fopen(filename, "wt")) != NULL)
	{
		for(i = 0; i <= coo_pointer[0]; i++)
		{
			for(j = 0; j < 4; j++)
			{
				fprintf(fpo, "%d,%d,%d,", servo_data[j][i][0], servo_data[j][i][1], servo_data[j][i][2]);
			}
			fprintf(fpo,"\n");
		}
		fclose(fpo);
	}
	else
	{
		printf("ݗpt@CJ܂Bleg_dmake2: %s\n",filename);
		exit(0);
	}
	return;
}

/**************************************************************/
/**  ^Ɋe֐߂ɏo߂̃f[^쐬iɐj      **/
/**  (׍r̈ʑ0x)                                 **/
/**  `OAᑬspg`                                **/
/**  filename  :T[{f[^o̓t@CirS{j       **/
/**************************************************************/
void leg_dmake7(char filename[16], struct LEG_PARAM leg_param[4], struct WAVE_PARAM wave_param)
{
int     i,j,flg,step_num;
int     coo_pointer[10],servo_data[4][WAVE_MAX2][3];
double   foot_coo0[4][WAVE_MAX2][3], diff[1][3];
double   foot_coo1[WAVE_MAX2][3];
double   length,height,step;
double   dyy,off_z, leg_sign[4];
double   foot_geo[6][3];
double   x,y,z,q0,r0,foot_r[6],foot_q[6],foot_l[6],PI;
double	time[4];
FILE	*fpo;

	leg_sign[0] = 1.0;
	leg_sign[1] = 1.0;
	leg_sign[2] =-1.0;
	leg_sign[3] =-1.0;

	PI = 3.14159;
	/*p[^*************************************************/
	length	= wave_param.length;
	height	= wave_param.height;
	dyy		= wave_param.off_y;
	off_z	= wave_param.off_z;
	time[0] = wave_param.time[0];
	time[1] = wave_param.time[1];
	time[3] = wave_param.time[3];
	r0		= wave_param.r;

//	time[1] = time[0] * 0.7;//グ
	time[2] = time[0] * 0.2;//Oɑ
//	time[3] = time[0] * 0.8;//낷

	//O
	/**er̋OՂ̔aZbg*************************************/
	/*̒SWZbg*/
	x = 0.0;
	y = r0;
	z = 0.0;
	for(i = 0; i < 4; i++)
	{
	   /*er̈ʒu֌W`*/
	   foot_geo[i][0] = leg_param[i].x;
	   foot_geo[i][1] = leg_param[i].y + dyy * leg_sign[i];
	   foot_geo[i][2] = leg_param[i].z;

	   /*̒Ser̒ʒu܂ł̋vZ*/
	   foot_r[i] = sqrt(pow((foot_geo[i][0] - x), 2)
	      + pow((foot_geo[i][1] - y), 2) + pow((foot_geo[i][2] - z), 2));
	
	   /*̒SƁA{bg̒S񂾐
	@              er̒ʒu܂ł̊pxvZ*/
	   foot_q[i] = atan2((foot_geo[i][1] - y), (foot_geo[i][0] - x))
			- PI / 2.0;

	   /*er̋OՂ̑ڒn̋OՂ̒vZ*/
	   q0 = length / r0;
	   foot_l[i] = fabs(foot_r[i] * q0);

	   /*XebvvZ*/
	   step_num = (int)(length / step);

	   /*̋OՁi~̒~j*********************************/
	   coo_pointer[9] = (int)r0;
	   tur_orbit2(foot_r[i], foot_l[i], height, time,	foot_coo1, coo_pointer);

	   /*j=LȔz̍ől*/
	   j = coo_pointer[0] + 1; /*palla_conv3Dstrorbit1͔ẑl`w̌Ⴄ*/

	   /*eOՃf[^]*/
	   rotate_1DZ(foot_coo1, 0.0, 0.0, foot_q[i], j);

	   /*e֐߂j[g̎̈ʒuɋOՂ𕽍sړ*/
	   diff[0][0] = leg_param[i].dx;
	   diff[0][1] = leg_param[i].dy + dyy * leg_sign[i];
	   diff[0][2] = leg_param[i].dz + off_z;

	   palla_conv3D(foot_coo1, diff, j, 1.0);

	   /*g`ʒuŏI悤ɃVtg*/
//		wave_shift2(coo_pointer[1] + 1, coo_pointer[0], foot_coo1);
		wave_shift(coo_pointer[1], coo_pointer[0], foot_coo1, foot_coo0[i]);
	}

	for(i = 0; i <= coo_pointer[0]; i++)
	{
		for(j = 0; j < 4; j++)
		{
			//T[{f[^ɕϊ
			if(j == 0 || j == 1)
			{
				flg = legP_dcomv12(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}
			else
			{
				flg = legP_dcomv32(foot_coo0[j][i], servo_data[j][i], leg_param[j], 0);
			}

			if(flg == 1)
			{
				printf("͂Ȃꏊw܂Bleg_dmake1\n");
				exit(0);
			}
		}
	}

	//t@Cɏ
	if ((fpo = fopen(filename, "wt")) != NULL)
	{
		for(i = 0; i <= coo_pointer[0]; i++)
		{
			for(j = 0; j < 4; j++)
			{
				fprintf(fpo, "%d,%d,%d,", servo_data[j][i][0], servo_data[j][i][1], servo_data[j][i][2]);
			}
			fprintf(fpo,"\n");
		}
		fclose(fpo);
	}
	else
	{
		printf("ݗpt@CJ܂Bleg_dmake2: %s\n",filename);
		exit(0);
	}
	return;
}

